unit testlrat;

interface

implementation
uses lrat, dunit, stream;

type
  TlratTest = class(TTest)
  published
    procedure testReadFromStream;
    procedure testGyakusu;
    procedure testFractMaxDigits;
    procedure testAsFract2;
end;

procedure TlratTest.testReadFromStream;
var
    aRational:TLoRational;
    aStream:StringStream;
begin
    aRational := TLoRational.Create(0,1);
    aStream := StringStream.fromString('3/4');
    try
        aRational.readFromStream(aStream);
        Test(aRational.asString, '3/4');
    finally
        aRational.free;
        aStream.free;
    end;
end;

procedure TlratTest.testGyakusu;
var
    aRational:TLoRational;
begin
    aRational := TLoRational.Create(2,3);
    try
        aRational.gyakusu;
        Test(aRational.asString, '3/2');
    finally
        aRational.free;
    end;
end;

procedure TlratTest.testFractMaxDigits;
var
    aRational:TLoRational;
    str:string;
begin
    aRational := TLoRational.Create(1,7);
    try
        TLoRational.setDefaultFractMaxDigits(5);
        Test(TLorational.getDefaultFtactMaxDigits, 5);
        str := aRational.asFraction2(false);
        Test(length(str), 7);
        Test(TLorational.getDefaultFtactMaxDigits, 5);
        str := aRational.asFraction2(false, 12);
        Test(length(str), 14);
        str := aRational.asFraction2(false, 300);
        Test(length(str), 302);
        //z̏ꍇɂ͍lĂȂ
        //@todo z̔ȂƂ悤ɂ悤
        //str := aRational.asFraction2(true, 3);
        //Test(length(str), 5);
    finally
        aRational.free;
    end;
end;

procedure TlratTest.testAsFract2;
var
    aRational, bRational:TLoRational;
begin
    aRational := TLoRational.Create(7,1);
    bRational := TLoRational.Create(9,8);
    try
        Test(aRational.asFraction2(false), '7');
        Test(bRational.asFraction2(false), '1.125');
    finally
        aRational.free;
        bRational.free;
    end;
end;

initialization
  TestSuite.Add(TlratTest);
end.
